Bug 11375 - --with=@listfile
: --with=@listfile
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/mkinitrd)
: unstable
: all Linux
: P2 enhancement
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2007-04-05 18:11 by
Modified: 2012-11-04 15:47 (History)


Attachments
mkinitrd-3.0.3-lists.patch (1.66 KB, patch)
2007-04-05 18:12, led@altlinux.org
no flags Details | Diff
mkinitrd-3.0.3-lists.patch (1.63 KB, patch)
2007-04-10 14:52, led@altlinux.org
no flags Details | Diff


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2007-04-05 18:11:56
Предлагаю патч для mkinitrd для возможности указания файла-списка модулей в 
качестве параметра --with. Я нашёл это полезным при автоматической генерации 
initrd.img для бездисковых терминалов при имеющемся файле-списке kernel-модулей 
наоболее распространённых Ethernet-адаптеров.
------- Comment #1 From 2007-04-05 18:12:35 -------
Created an attachment (id=1888) [details]
mkinitrd-3.0.3-lists.patch
------- Comment #2 From 2007-04-06 23:09:15 -------
Какой же это listfile, когда на самом деле происходит не чтение списка модулей
из файла, а поиск всех модулей в указанном подкаталоге?  Это примерно
соответствует опции --type в modprobe.

У меня есть подозрение, что опция в таком виде будет не слишком полезна,
поскольку в ядрах 2.6.x, в отличие от 2.4.x, модули драйверов PCI-устройств
успешно загружаются даже в том случае, если соответствующие устройства не
обнаружены.  С другой стороны, поскольку сейчас в initramfs запускается udev,
возможна автоматическая загрузка модулей по modalias - для этого необходимо
просто скопировать модули в initramfs, не добавляя их в список для загрузки;
сейчас в mkinitrd нет опции для этого.

Замечание по поводу реализации: конструкции вида ${1:0:1} требуют bash - в
данном случае вполне можно обойтись без них.
------- Comment #3 From 2007-04-10 14:10:15 -------
(In reply to comment #2) 
> Какой же это listfile, когда на самом деле происходит не чтение списка 
модулей 
> из файла, а поиск всех модулей в указанном подкаталоге?  Это примерно 
> соответствует опции --type в modprobe. 
 
Виноват, это я так невнимательно "почистил" патчик перед тем, как залить :( 
 
>  
> У меня есть подозрение, что опция в таком виде будет не слишком полезна, 
> поскольку в ядрах 2.6.x, в отличие от 2.4.x, модули драйверов PCI-устройств 
> успешно загружаются даже в том случае, если соответствующие устройства не 
> обнаружены.  С другой стороны, поскольку сейчас в initramfs запускается udev, 
> возможна автоматическая загрузка модулей по modalias - для этого необходимо 
> просто скопировать модули в initramfs, не добавляя их в список для загрузки; 
> сейчас в mkinitrd нет опции для этого. 
 
ИМХО предложенное расширение вроде ничему не мешает, тем более, что опции 
"добавления без загрузки" сейчас нет? (Правильный патч я, конечно же, залью 
сегодня) 
 
>  
> Замечание по поводу реализации: конструкции вида ${1:0:1} требуют bash - в 
> данном случае вполне можно обойтись без них. 
 
Согласен: непризволный "башизм":) Могу заменить на 
grep -q '^@' 
------- Comment #4 From 2007-04-10 14:52:00 -------
Created an attachment (id=1899) [details]
mkinitrd-3.0.3-lists.patch

Теперь, вроде, правильный патч...
------- Comment #5 From 2009-12-09 05:14:32 -------
At this time, I'm reluctant to add any enhancements to this monolithic
mkinitrd.

Please have a look at another implementations that have modular architecture,
e.g. make-initrd by Alexey Gladkov and Kirill Shutemov.
------- Comment #6 From 2012-11-04 15:47:52 -------
mkinitrd-1:3.0.12-alt1 -> sisyphus:

* Sun Nov 04 2012 Led <led@altlinux> 1:3.0.12-alt1
- 3.0.12:
  + mkinitrd: find modules in modules.alias if modules.pcimap not exists
  + mkinitrd: added modules.builtin and modules.order to tree
  + mkinitrd: added kmod support
  + mkinitrd: copy /lib/udev/dm_export only if it exists
  + mkinitrd: added support xz and lzo compressing
  + mkinitrd: added --with-nbd
  + scripts/local: use fs type 'auto' if unknown
  + init: added support parameters for loading modules
  + init: added 'modules=' kernel parameter support
  + rewrote script 'dhcp' to 'ip'
  + added support 'netdev' kernel parameter
  + added scripts/nbd_*
  + mkinitrd: added --root and --rootfs options
  + added support boot from nbd (ALT#15466)
  + mkinitrd: added support list file for --preload|--with|--extra (ALT#11375)
  + mkinitrd: removed unsupported image types
  + mkinitrd: added support /etc/sysconfig/mkinitrd config
  + mkinitrd: added lzma, xz, lzo and bzip2 compression (ALT#21588)
  + applied patch from http://bugzilla.altlinux.org/show_bug.cgi?id=19388
    for LVM2 support in initrd